package de.cdiag.jugdo.arquillian.bl.ejb;

import java.util.List;

import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

import de.cdiag.jugdo.arquillian.bl.CustomerService;
import de.cdiag.jugdo.arquillian.domain.Customer;

/**
 * Service implementation with persistence context.
 * 
 * @author Sebastian Lammering, CDI AG (www.cdi-ag.de)
 *
 */
@Stateless
public class CustomerServiceBean implements CustomerService {
	
	@PersistenceContext
	private EntityManager entityManager;

	public List<Customer> getAll() {
		@SuppressWarnings("unchecked")
		List<Customer> resultList = entityManager.createQuery("FROM Customer").getResultList();
		return resultList;
	}

	public Customer getByKey(String key) {
		Query query = entityManager.createQuery("FROM Customer WHERE key = :key");
		query.setParameter("key", key);
		@SuppressWarnings("unchecked")
		List<Customer> resultList = query.getResultList();
		return resultList.isEmpty() ? null : resultList.get(0);
	}

	public Customer save(Customer customer) {
		if (customer.getId() == null) {
			entityManager.persist(customer);
			return customer;
		} else {
			return entityManager.merge(customer);
		}
	}

}
